<?php

namespace Drupal\skilling_history\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Form\FormStateInterface;

/**
 * Class SkillingHistoryForm
 */
class SkillingHistoryForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   */
  public function save(array $form, FormStateInterface $form_state) {
    $entity = &$this->entity;
    $message_params = [
      '%entity_label' => $entity->getName(),
      '%content_entity_label' => $entity->getEntityType()->getLabel()->render(),
      '%bundle_label' => $entity->bundle->entity->label(),
    ];

    $status = parent::save($form, $form_state);

    switch ($status) {
      case SAVED_NEW:
        $this->messenger()->addStatus(
          $this->t('Created the %bundle_label - %content_entity_label entity:  %entity_label.', $message_params )
        );
        break;

      default:
        $this->messenger()->addStatus(
          $this->t('Saved the %bundle_label - %content_entity_label entity:  %entity_label.', $message_params)
        );
    }

    $content_entity_id = $entity->getEntityType()->id();
    $form_state->setRedirect("entity.{$content_entity_id}.canonical", [$content_entity_id => $entity->id()]);
  }
}
